#include "stdinc.h"
#include "balance.h"
#include "pcs.h"

unsigned int query_upload_ip()
{
	// open share memory to read server info
	size_t shmsize = sizeof(ServerNodeInfo) + sizeof(ImgNodeInfo) * MAX_IMG_NODE - sizeof(ImgNodeInfo);
	int shmid = shmget(0x344521,shmsize,0666);
	if (-1 == shmid)
	{
		// can not read img nodes infomation
		return 0;
	}

	ServerNodeInfo * serverinfos = (ServerNodeInfo *)shmat(shmid,NULL,0);

	// get the max baudwidth server info
	HPCS hpcs = pcs_create(SEM_KEY);
	pcs_entercs(hpcs);
	int i;
	unsigned int maxbaudip = 0;
	int maxfreebaud = 0;
	for (i = 0; i < serverinfos->uiNodeCount; i++)
	{
		if (serverinfos->nodes[i].i64FreeDisk > 1024)
		{
			if (maxfreebaud < serverinfos->nodes[i].uiFreeBaudwidth)
			{
				maxfreebaud = serverinfos->nodes[i].uiFreeBaudwidth;
				maxbaudip = serverinfos->nodes[i].uiIp;
			}
		}
	}
	pcs_leavecs(hpcs);
	pcs_destroy(hpcs);

	// free share memory
	shmdt((void *)serverinfos);
	return maxbaudip;
}
