#ifndef __DVR_SHM_
#define __DVR_SHM_

#define TIMPORT_SHM_FILE  "/svrhome/data/shmbak"

#define UID_LEN   32

#include <sys/types.h>

typedef struct _dev_s
{
    u_int8_t  uid[UID_LEN];
    u_int32_t  conn_key;

    u_int8_t   proto;
    u_int32_t  ip;
    u_int16_t  port;

    u_int8_t   status;
    u_int8_t   nettype;
    u_int32_t  tick;
    u_int32_t  last;
    char       key[16];
    char       nonce[16];
    u_int8_t   app_num;
    u_int8_t  *turn_app;
    char       fwversion[32];
    char       version[32];
    char       odm[16];
    char       area[4];
    int32_t    max_ch;
}__attribute__((packed))DEV_t;

/* return shm_addr*/
void *dvr_shm_init();
void dvr_shm_deinit(void *shm_addr);

/* shm_addr from dvr_shm_init
 * uid zs32322323232,
 */
void *dvr_shm_get(void *shm_addr, char *uid);

typedef int (*DVR_WALK_CB)(void *data, void *arg);
int dvr_shm_walk(void *shm_addr, DVR_WALK_CB walk_cb, void *arg);
int shm_hash_import_one_node(void *shm_addr, void *key, char *node, u_int32_t nodesize);

#endif

