#include "stdinc.h"
#include "pcs.h"

typedef struct _tagPcs{
	int sem_id;
	int iscreate;
}Pcs;

union semun
{
	int val;
	struct semid_ds * buf;
	unsigned short * array;
};

HPCS pcs_create( key_t key )
{
	Pcs * pcs = (Pcs *)malloc(sizeof(Pcs));
	pcs->iscreate = 0;
	pcs->sem_id = semget(key, 1, 0666 | IPC_CREAT | IPC_EXCL);
	if ( -1 == pcs->sem_id && EEXIST == errno)
	{
		pcs->sem_id = semget(key, 1, 0666 | IPC_CREAT);
	}
	else
	{
		pcs->iscreate = 1;
		union semun val;
		val.val = 1;
		if (semctl(pcs->sem_id, 0, SETVAL, val) == -1) return NULL;
	}

	return (HPCS)pcs;
}

void pcs_destroy( HPCS hpcs )
{
	Pcs * pcs = (Pcs *)hpcs;
	if (pcs->iscreate)
	{
		union semun t;
		semctl(pcs->sem_id, 0, IPC_RMID, t);
	}

	free(pcs);
}

int pcs_entercs( HPCS hpcs )
{
	Pcs * pcs = (Pcs *)hpcs;
	struct sembuf b;
	b.sem_num = 0;
	b.sem_op = -1;
	b.sem_flg = SEM_UNDO;
	if (semop(pcs->sem_id, &b, 1) == -1) return -1;
	return 0;
}

int pcs_leavecs( HPCS hpcs )
{
	Pcs * pcs = (Pcs *)hpcs;
	struct sembuf b;
	b.sem_num = 0;
	b.sem_op = 1;
	b.sem_flg = SEM_UNDO;
	if (semop(pcs->sem_id, &b, 1) == -1) return -1;
	return 0;
}

